package com.mortals.xhx.module.goview.service.impl;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.xhx.module.goview.dao.GoviewProjectDao;
import com.mortals.xhx.module.goview.model.GoviewProjectDataEntity;
import com.mortals.xhx.module.goview.model.GoviewProjectDataQuery;
import com.mortals.xhx.module.goview.model.GoviewProjectEntity;
import com.mortals.xhx.module.goview.service.GoviewProjectDataService;
import com.mortals.xhx.module.goview.service.GoviewProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
* GoviewProjectService
* 项目 service实现
*
* @author zxfei
* @date 2023-04-13
*/
@Service("goviewProjectService")
public class GoviewProjectServiceImpl extends AbstractCRUDServiceImpl<GoviewProjectDao, GoviewProjectEntity, Long> implements GoviewProjectService {

    @Autowired
    private GoviewProjectDataService goviewProjectDataService;

    @Override
    protected void saveBefore(GoviewProjectEntity entity, Context context) throws AppException {
        this.validData(entity, context);
        entity.setState(-1);
    }

    @Override
    protected void removeAfter(Long[] ids, Context context, int result) throws AppException {
        List<Long> projectIdList = new ArrayList<>();
        for(Long id:ids){
            projectIdList.add(id);
        }
        List<GoviewProjectDataEntity> list = goviewProjectDataService.find(new GoviewProjectDataQuery().projectIdList(projectIdList));
        List<Long> dataIds = new ArrayList<>();
        for(GoviewProjectDataEntity item:list){
            dataIds.add(item.getId());
        }
        goviewProjectDataService.remove(dataIds.toArray(new Long[dataIds.size()]),context);
    }
}